#include "Cmd.h"
#include "MotorCtl.h"
#include "Fsm.h"
#include "Arduino.h"
#include "prf.h"



// Command parser variables
static char     cmd[40];
static int      icmd = 0;


//*************************************************************************
// Run command parser
//*************************************************************************
void commandParser(void) 
{
  char           c;
  char          *p;
  char          *p1;
  char          *p2;


  /* If serial data is available */  
  if (Serial.available() > 0) 
  {
   
    /* Read the next byte */
    c = Serial.read();
   
    /* If the end of a command */
    if ((c == '\n') || (c== '\r')) 
    {
      
      /* Null terminate the command */
      cmd[icmd] = 0;
       
      for(int i = 0; cmd[i]; i++)
      {
        cmd[i] = toupper(cmd[i]);
      }       

     
      /* Parse out the first token */
      p = strtok(cmd, " ");

      /* Test for each command */
       
      /* X */       
      if (strcmp(p, "X") == 0) 
      {
        enter_STOP(micros());
        
      /* s */       
      } else if (strcmp(p, "S") == 0) 
      {         
          enter_SEEK_SCAN(micros());

      /* v */       
      } else if (strcmp(p, "V") == 0) 
      {

          p1 = strtok(NULL, " ");
          verbose = atoi(p1);
          Serial.println(verbose);


      /* P */       
      } else if (strcmp(p, "P") == 0) 
      {

          p1 = strtok(NULL, " ");
          kP = atof(p1);
          Serial.println(kP);

      /* I */       
      } else if (strcmp(p, "I") == 0) 
      {

          p1 = strtok(NULL, " ");
          kI = atof(p1);
          Serial.println(kI);

      /* D */       
      } else if (strcmp(p, "D") == 0) 
      {

          p1 = strtok(NULL, " ");
          kD = atof(p1);
          Serial.println(kD);          

      /* C */       
      } else if (strcmp(p, "C") == 0) 
      {
          uint8_t code;

          p1 = strtok(NULL, " ");
          code = atoi(p1);
          Serial.println(code);          
          // Set PRF to track code 
          prfSetCode(code);

          
      /* ? */       
      } else if (strcmp(p, "?") == 0) 
      {
         Serial.println("Usage:");
         Serial.println(" X         - Panic stop");
         Serial.println(" S n       - Set speed");
         Serial.println(" V n       - Set verbose mode");
         Serial.println(" !         - Print info");
         
      /* ! */       
      } else if (strcmp(p, "!") == 0) 
      {
         Serial.print("S, ");             Serial.println(pwmSpeed);
         Serial.println("");
         
         
      /* Not a valid command */  
      } else {
         Serial.print("Bad command (");
         Serial.print(p);
         Serial.println(")");
      }
     
       /* Now that we parsed the command, reset for next command */
       icmd=0;

     /* If this is not a terminator */     
     } else 
     {
       
       /* Append the character to the command buffer */
       cmd[icmd] = c;
       icmd++;
       if (icmd >= 80) {
         Serial.println("Command buffer overflow");
         icmd = 0;
       }
     } /* end terminator */
   } /* end character available */
}

