
#ifndef __FSM_H__
#define __FSM_H__

#include <stdint.h>

extern uint16_t verbose;
extern float    hdgDeg;
extern float    hdgTurn;
extern float    hdgTgt;
extern bool     hdgMode;
extern bool     prfStatusChanged;
extern int16_t  pwmSpeed;
extern bool     edge;






// Enumeration of FSM states
typedef enum 
{
    WAIT_FOR_DMP,  // 0
    SEEK_FWD,      // 1
    SEEK_SCAN,     // 2
    TRACK_FWD,     // 3
    EDGE_BACK,     // 4
    STOP           // 5
} Mode_e;

void  processFsm(uint32_t now);
void  enter_WAIT_FOR_DMP(uint32_t now);
void  enter_STOP(uint32_t now);
void  enter_SEEK_FWD(uint32_t now);
void  enter_SEEK_SCAN(uint32_t now);


void setHdgBias(float bias);


#endif
